/* include/asm-arm7/arch-lpc2xxx/lcp2xxx.h
 *
 * Copyright (C) 2007 David Cohen <dacohen@gmail.com>
 * Copyright (C) 2007 Felipe Balbi <me@felipebalbi.com>
 *
 * This file is part of Tinyx Nanokernel Project.
 *
 * Tinyx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tinyx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tinyx.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MACH_LPC2XXX_H
#define __MACH_LPC2XXX_H

/* External Memory Controller (EMC) */
#define BCFG0			0xFFE00000
#define BCFG1			0xFFE00004
#define BCFG2			0xFFE00008
#define BCFG3			0xFFE0000C

/* Vectored Interrupt Controller (VIC) */
#define VICIRQSTATUS		0xFFFFF000
#define VICFIQSTATUS		0xFFFFF004
#define VICRAWINTR		0xFFFFF008
#define VICINTSELECT		0xFFFFF00C
#define VICINTENABLE		0xFFFFF010
#define VICINTENCLR		0xFFFFF014
#define VICSOFTINT		0xFFFFF018
#define VICSOFTINTCLR		0xFFFFF01C
#define VICPROTECTION		0xFFFFF020
#define VICVECTADDR		0xFFFFF030
#define VICDEFVECTADDR		0xFFFFF034
#define VICVECTADDR0		0xFFFFF100
#define VICVECTADDR1		0xFFFFF104
#define VICVECTADDR2		0xFFFFF108
#define VICVECTADDR3		0xFFFFF10C
#define VICVECTADDR4		0xFFFFF110
#define VICVECTADDR5		0xFFFFF114
#define VICVECTADDR6		0xFFFFF118
#define VICVECTADDR7		0xFFFFF11C
#define VICVECTADDR8		0xFFFFF120
#define VICVECTADDR9		0xFFFFF124
#define VICVECTADDR10		0xFFFFF128
#define VICVECTADDR11		0xFFFFF12C
#define VICVECTADDR12		0xFFFFF130
#define VICVECTADDR13		0xFFFFF134
#define VICVECTADDR14		0xFFFFF138
#define VICVECTADDR15		0xFFFFF13C
#define VICVECTCNTL0		0xFFFFF200
#define VICVECTCNTL1		0xFFFFF204
#define VICVECTCNTL2		0xFFFFF208
#define VICVECTCNTL3		0xFFFFF20C
#define VICVECTCNTL4		0xFFFFF210
#define VICVECTCNTL5		0xFFFFF214
#define VICVECTCNTL6		0xFFFFF218
#define VICVECTCNTL7		0xFFFFF21C
#define VICVECTCNTL8		0xFFFFF220
#define VICVECTCNTL9		0xFFFFF224
#define VICVECTCNTL10		0xFFFFF228
#define VICVECTCNTL11		0xFFFFF22C
#define VICVECTCNTL12		0xFFFFF230
#define VICVECTCNTL13		0xFFFFF234
#define VICVECTCNTL14		0xFFFFF238
#define VICVECTCNTL15		0xFFFFF23C

/* Pin Connect Block */
#define PINSEL0			0xE002C000
#define PINSEL1			0xE002C004
#define PINSEL2			0xE002C014

/* General Purpose Input/Output (GPIO) */
#define IOPIN			0xE0028000
#define IOSET			0xE0028004
#define IODIR			0xE0028008
#define IOCLR			0xE002800C

#define IOPIN0			0xE0028000
#define IOSET0			0xE0028004
#define IODIR0			0xE0028008
#define IOCLR0			0xE002800C
#define IOPIN1			0xE0028010
#define IOSET1			0xE0028014
#define IODIR1			0xE0028018
#define IOCLR1			0xE002801C
#define IOPIN2			0xE0028020
#define IOSET2			0xE0028024
#define IODIR2			0xE0028028
#define IOCLR2			0xE002802C
#define IOPIN3			0xE0028030
#define IOSET3			0xE0028034
#define IODIR3			0xE0028038
#define IOCLR3			0xE002803C

/* Fast I/O setup */
#define FIO_BASE_ADDR		0x3FFFC000
#define FIO0DIR			0x3FFFC000
#define FIO0MASK		0x3FFFC010
#define FIO0PIN			0x3FFFC014
#define FIO0SET			0x3FFFC018
#define FIO0CLR			0x3FFFC01C
#define FIO1DIR			0x3FFFC020
#define FIO1MASK		0x3FFFC030
#define FIO1PIN			0x3FFFC034
#define FIO1SET			0x3FFFC038
#define FIO1CLR			0x3FFFC03C

/* Memory Accelerator Module (MAM) */
#define MAMCR			0xE01FC000
#define MAMTIM			0xE01FC004
#define MAMMAP			0xE01FC040

/* Phase Locked Loop (PLL) */
#define PLLCON			0xE01FC080
#define PLLCFG			0xE01FC084
#define PLLSTAT			0xE01FC088
#define PLLFEED			0xE01FC08C

/* PLL48 Registers */
#define PLL48CON		0xE01FC0A0
#define PLL48CFG		0xE01FC0A4
#define PLL48STAT		0xE01FC0A8
#define PLL48FEED		0xE01FC0AC

/* Power Control */
#define PCON			0xE01FC0C0
#define PCONP			0xE01FC0C4

/* VPB Divider */
#define VPBDIV			0xE01FC100

/* External Interrupts */
#define EXTINT			0xE01FC140
#define EXTWAKE			0xE01FC144
#define EXTMODE			0xE01FC148
#define EXTPOLAR		0xE01FC14C

/* Reset */
#define RSIR			0xE01FC180

/* System Controls and Status */
#define SCS			0xE01FC1A0

/* Timer 0 */
#define TIMER0_IR		0xE0004000
#define TIMER0_TCR		0xE0004004
#define TIMER0_TC		0xE0004008
#define TIMER0_PR		0xE000400C
#define TIMER0_PC		0xE0004010
#define TIMER0_MCR		0xE0004014
#define TIMER0_MR0		0xE0004018
#define TIMER0_MR1		0xE000401C
#define TIMER0_MR2		0xE0004020
#define TIMER0_MR3		0xE0004024
#define TIMER0_CCR		0xE0004028
#define TIMER0_CR0		0xE000402C
#define TIMER0_CR1		0xE0004030
#define TIMER0_CR2		0xE0004034
#define TIMER0_CR3		0xE0004038
#define TIMER0_EMR		0xE000403C
#define TIMER0_CTCR		0xE0004070

#define T0IR			0xE0004000
#define T0TCR			0xE0004004
#define T0TC			0xE0004008
#define T0PR			0xE000400C
#define T0PC			0xE0004010
#define T0MCR			0xE0004014
#define T0MR0			0xE0004018
#define T0MR1			0xE000401C
#define T0MR2			0xE0004020
#define T0MR3			0xE0004024
#define T0CCR			0xE0004028
#define T0CR0			0xE000402C
#define T0CR1			0xE0004030
#define T0CR2			0xE0004034
#define T0CR3			0xE0004038
#define T0EMR			0xE000403C
#define T0CTCR			0xE0004070

/* Timer 1 */
#define TIMER1_IR		0xE0008000
#define TIMER1_TCR		0xE0008004
#define TIMER1_TC		0xE0008008
#define TIMER1_PR		0xE000800C
#define TIMER1_PC		0xE0008010
#define TIMER1_MCR		0xE0008014
#define TIMER1_MR0		0xE0008018
#define TIMER1_MR1		0xE000801C
#define TIMER1_MR2		0xE0008020
#define TIMER1_MR3		0xE0008024
#define TIMER1_CCR		0xE0008028
#define TIMER1_CR0		0xE000802C
#define TIMER1_CR1		0xE0008030
#define TIMER1_CR2		0xE0008034
#define TIMER1_CR3		0xE0008038
#define TIMER1_EMR		0xE000803C
#define TIMER1_CTCR		0xE0008070

#define T1IR			0xE0008000
#define T1TCR			0xE0008004
#define T1TC			0xE0008008
#define T1PR			0xE000800C
#define T1PC			0xE0008010
#define T1MCR			0xE0008014
#define T1MR0			0xE0008018
#define T1MR1			0xE000801C
#define T1MR2			0xE0008020
#define T1MR3			0xE0008024
#define T1CCR			0xE0008028
#define T1CR0			0xE000802C
#define T1CR1			0xE0008030
#define T1CR2			0xE0008034
#define T1CR3			0xE0008038
#define T1EMR			0xE000803C
#define T1CTCR			0xE0008070

/* Pulse Width Modulator (PWM) */
#define PWM_IR			0xE0014000
#define PWM_TCR			0xE0014004
#define PWM_TC			0xE0014008
#define PWM_PR			0xE001400C
#define PWM_PC			0xE0014010
#define PWM_MCR			0xE0014014
#define PWM_MR0			0xE0014018
#define PWM_MR1			0xE001401C
#define PWM_MR2			0xE0014020
#define PWM_MR3			0xE0014024
#define PWM_MR4			0xE0014040
#define PWM_MR5			0xE0014044
#define PWM_MR6			0xE0014048
#define PWM_CCR			0xE0014028
#define PWM_CR0			0xE001402C
#define PWM_CR1			0xE0014030
#define PWM_CR2			0xE0014034
#define PWM_CR3			0xE0014038
#define PWM_EMR			0xE001403C
#define PWM_PCR			0xE001404C
#define PWM_LER			0xE0014050

#define PWMIR			0xE0014000
#define PWMTCR			0xE0014004
#define PWMTC			0xE0014008
#define PWMPR			0xE001400C
#define PWMPC			0xE0014010
#define PWMMCR			0xE0014014
#define PWMMR0			0xE0014018
#define PWMMR1			0xE001401C
#define PWMMR2			0xE0014020
#define PWMMR3			0xE0014024
#define PWMMR4			0xE0014040
#define PWMMR5			0xE0014044
#define PWMMR6			0xE0014048
#define PWMCCR			0xE0014028
#define PWMCR0			0xE001402C
#define PWMCR1			0xE0014030
#define PWMCR2			0xE0014034
#define PWMCR3			0xE0014038
#define PWMEMR			0xE001403C
#define PWMPCR			0xE001404C
#define PWMLER			0xE0014050

/* Universal Asynchronous Receiver Transmitter 0 (UART0) */
#define UART0_RBR		0xE000C000
#define UART0_THR		0xE000C000
#define UART0_IER		0xE000C004
#define UART0_IIR		0xE000C008
#define UART0_FCR		0xE000C008
#define UART0_LCR		0xE000C00C
#define UART0_MCR		0xE000C010
#define UART0_LSR		0xE000C014
#define UART0_MSR		0xE000C018
#define UART0_SCR		0xE000C01C
#define UART0_ACR		0xE000C020
#define UART0_FDR		0xE000C028
#define UART0_TER		0xE000C030
#define UART0_DLL		0xE000C000
#define UART0_DLM		0xE000C004

#define U0RBR			0xE000C000
#define U0THR			0xE000C000
#define U0IER			0xE000C004
#define U0IIR			0xE000C008
#define U0FCR			0xE000C008
#define U0LCR			0xE000C00C
#define U0MCR			0xE000C010
#define U0LSR			0xE000C014
#define U0MSR			0xE000C018
#define U0SCR			0xE000C01C
#define U0ACR			0xE000C020
#define U0FDR			0xE000C028
#define U0TER			0xE000C030
#define U0DLL			0xE000C000
#define U0DLM			0xE000C004

/* Universal Asynchronous Receiver Transmitter 1 (UART1) */
#define UART1_RBR		0xE0010000
#define UART1_THR		0xE0010000
#define UART1_IER		0xE0010004
#define UART1_IIR		0xE0010008
#define UART1_FCR		0xE0010008
#define UART1_LCR		0xE001000C
#define UART1_MCR		0xE0010010
#define UART1_LSR		0xE0010014
#define UART1_MSR		0xE0010018
#define UART1_SCR		0xE001001C
#define UART1_ACR		0xE0010020
#define UART1_FDR		0xE0010028
#define UART1_TER		0xE0010030
#define UART1_DLL		0xE0010000
#define UART1_DLM		0xE0010004

#define U1RBR			0xE0010000
#define U1THR			0xE0010000
#define U1IER			0xE0010004
#define U1IIR			0xE0010008
#define U1FCR			0xE0010008
#define U1LCR			0xE001000C
#define U1MCR			0xE0010010
#define U1LSR			0xE0010014
#define U1MSR			0xE0010018
#define U1SCR			0xE001001C
#define U1ACR			0xE0010020
#define U1FDR			0xE0010028
#define U1TER			0xE0010030
#define U1DLL			0xE0010000
#define U1DLM			0xE0010004

/* I2C Interface 0 */
#define I2C_I2CONSET		0xE001C000
#define I2C_I2STAT		0xE001C004
#define I2C_I2DAT		0xE001C008
#define I2C_I2ADR		0xE001C00C
#define I2C_I2SCLH		0xE001C010
#define I2C_I2SCLL		0xE001C014
#define I2C_I2CONCLR		0xE001C018

#define I2CONSET		0xE001C000
#define I2STAT			0xE001C004
#define I2DAT			0xE001C008
#define I2ADR			0xE001C00C
#define I2SCLH			0xE001C010
#define I2SCLL			0xE001C014
#define I2CONCLR		0xE001C018

/* I2C Interface 1 */
#define I21CONSET		0xE005C000
#define I21STAT			0xE005C004
#define I21DAT			0xE005C008
#define I21ADR			0xE005C00C
#define I21SCLH			0xE005C010
#define I21SCLL			0xE005C014
#define I21CONCLR		0xE005C018

/* SPI (Serial Peripheral Interface) */
#define SPI_SPCR		0xE0020000
#define SPI_SPSR		0xE0020004
#define SPI_SPDR		0xE0020008
#define SPI_SPCCR		0xE002000C
#define SPI_SPTCR		0xE0020010
#define SPI_SPTSR		0xE0020014
#define SPI_SPTOR		0xE0020018
#define SPI_SPINT		0xE002001C

#define S0SPCR			0xE0020000
#define S0SPSR			0xE0020004
#define S0SPDR			0xE0020008
#define S0SPCCR			0xE002000C
#define S0SPTCR			0xE0020010
#define S0SPTSR			0xE0020014
#define S0SPTOR			0xE0020018
#define S0SPINT			0xE002001C

/* SPI1 (Serial Peripheral Interface 1) */
#define S1SPCR			0xE0030000
#define S1SPSR			0xE0030004
#define S1SPDR			0xE0030008
#define S1SPCCR			0xE003000C
#define S1SPTCR			0xE0030010
#define S1SPTSR			0xE0030014
#define S1SPTOR			0xE0030018
#define S1SPINT			0xE003001C

/* SSP Controller */
#define SSPCR0			0xE0068000
#define SSPCR1			0xE0068004
#define SSPDR			0xE0068008
#define SSPSR			0xE006800C
#define SSPCPSR			0xE0068010
#define SSPIMSC			0xE0068014
#define SSPRIS			0xE0068018
#define SSPMIS			0xE006801C
#define SSPICR			0xE0068020

/* Real Time Clock */
#define RTC_ILR			0xE0024000
#define RTC_CTC			0xE0024004
#define RTC_CCR			0xE0024008
#define RTC_CIIR		0xE002400C
#define RTC_AMR			0xE0024010
#define RTC_CTIME0		0xE0024014
#define RTC_CTIME1		0xE0024018
#define RTC_CTIME2		0xE002401C
#define RTC_SEC			0xE0024020
#define RTC_MIN			0xE0024024
#define RTC_HOUR		0xE0024028
#define RTC_DOM			0xE002402C
#define RTC_DOW			0xE0024030
#define RTC_DOY			0xE0024034
#define RTC_MONTH		0xE0024038
#define RTC_YEAR		0xE002403C
#define RTC_ALSEC		0xE0024060
#define RTC_ALMIN		0xE0024064
#define RTC_ALHOUR		0xE0024068
#define RTC_ALDOM		0xE002406C
#define RTC_ALDOW		0xE0024070
#define RTC_ALDOY		0xE0024074
#define RTC_ALMON		0xE0024078
#define RTC_ALYEAR		0xE002407C
#define RTC_PREINT		0xE0024080
#define RTC_PREFRAC		0xE0024084

#define ILR			0xE0024000
#define CTC			0xE0024004
#define CCR			0xE0024008
#define CIIR			0xE002400C
#define AMR			0xE0024010
#define CTIME0			0xE0024014
#define CTIME1			0xE0024018
#define CTIME2			0xE002401C
#define SEC			0xE0024020
#define MIN			0xE0024024
#define HOUR			0xE0024028
#define DOM			0xE002402C
#define DOW			0xE0024030
#define DOY			0xE0024034
#define MONTH			0xE0024038
#define YEAR			0xE002403C
#define ALSEC			0xE0024060
#define ALMIN			0xE0024064
#define ALHOUR			0xE0024068
#define ALDOM			0xE002406C
#define ALDOW			0xE0024070
#define ALDOY			0xE0024074
#define ALMON			0xE0024078
#define ALYEAR			0xE002407C
#define PREINT			0xE0024080
#define PREFRAC			0xE0024084

/* A/D Converter */
#define ADCR			0xE0034000
#define ADDR			0xE0034004
#define AD1CR			0xE0060000
#define AD1DR			0xE0060004

/* D/A Converter */
#define DACR			0xE006C000

/* USB Controller */
/* Device Interrupt Registers */
#define DEV_INT_STAT		0xE0090000
#define DEV_INT_EN		0xE0090004
#define DEV_INT_CLR		0xE0090008
#define DEV_INT_SET		0xE009000C
#define DEV_INT_PRIO		0xE009002C

/* Endpoint Interrupt Registers */
#define EP_INT_STAT		0xE0090030
#define EP_INT_EN		0xE0090034
#define EP_INT_CLR		0xE0090038
#define EP_INT_SET		0xE009003C
#define EP_INT_PRIO		0xE0090040

/* Endpoint Realization Registers */
#define REALIZE_EP		0xE0090044
#define EP_INDEX		0xE0090048
#define MAXPACKET_SIZE		0xE009004C

/* Command Reagisters */
#define CMD_CODE		0xE0090010
#define CMD_DATA		0xE0090014

/* Data Transfer Registers */
#define RX_DATA			0xE0090018
#define TX_DATA			0xE009001C
#define RX_PLENGTH		0xE0090020
#define TX_PLENGTH		0xE0090024
#define USB_CTRL		0xE0090028

/* DMA Registers */
#define DMA_REQ_STAT		0xE0090050
#define DMA_REQ_CLR		0xE0090054
#define DMA_REQ_SET		0xE0090058
#define UDCA_HEAD		0xE0090080
#define EP_DMA_STAT		0xE0090084
#define EP_DMA_EN		0xE0090088
#define EP_DMA_DIS		0xE009008C
#define DMA_INT_STAT		0xE0090090
#define DMA_INT_EN		0xE0090094
#define EOT_INT_STAT		0xE00900A0
#define EOT_INT_CLR		0xE00900A4
#define EOT_INT_SET		0xE00900A8
#define NDD_REQ_INT_STAT	0xE00900AC
#define NDD_REQ_INT_CLR		0xE00900B0
#define NDD_REQ_INT_SET		0xE00900B4
#define SYS_ERR_INT_STAT	0xE00900B8
#define SYS_ERR_INT_CLR		0xE00900BC
#define SYS_ERR_INT_SET		0xE00900C0
#define MODULE_ID		0xE00900FC

/* CAN Acceptance Filter RAM */
#define AFRAM			0xE0038000

/* CAN Acceptance Filter */
#define AFMR			0xE003C000
#define SFF_sa			0xE003C004
#define SFF_GRP_sa		0xE003C008
#define EFF_sa			0xE003C00C
#define EFF_GRP_sa		0xE003C010
#define ENDofTable		0xE003C014
#define LUTerrAd		0xE003C018
#define LUTerr			0xE003C01C

/* CAN Central Registers */
#define CANTxSR			0xE0040000
#define CANRxSR			0xE0040004
#define CANMSR			0xE0040008

/* CAN Controller 1 (CAN1) */
#define C1MOD			0xE0044000
#define C1CMR			0xE0044004
#define C1GSR			0xE0044008
#define C1ICR			0xE004400C
#define C1IER			0xE0044010
#define C1BTR			0xE0044014
#define C1EWL			0xE0044018
#define C1SR			0xE004401C
#define C1RFS			0xE0044020
#define C1RID			0xE0044024
#define C1RDA			0xE0044028
#define C1RDB			0xE004402C
#define C1TFI1			0xE0044030
#define C1TID1			0xE0044034
#define C1TDA1			0xE0044038
#define C1TDB1			0xE004403C
#define C1TFI2			0xE0044040
#define C1TID2			0xE0044044
#define C1TDA2			0xE0044048
#define C1TDB2			0xE004404C
#define C1TFI3			0xE0044050
#define C1TID3			0xE0044054
#define C1TDA3			0xE0044058
#define C1TDB3			0xE004405C

/* CAN Controller 2 (CAN2) */
#define C2MOD			0xE0048000
#define C2CMR			0xE0048004
#define C2GSR			0xE0048008
#define C2ICR			0xE004800C
#define C2IER			0xE0048010
#define C2BTR			0xE0048014
#define C2EWL			0xE0048018
#define C2SR			0xE004801C
#define C2RFS			0xE0048020
#define C2RID			0xE0048024
#define C2RDA			0xE0048028
#define C2RDB			0xE004802C
#define C2TFI1			0xE0048030
#define C2TID1			0xE0048034
#define C2TDA1			0xE0048038
#define C2TDB1			0xE004803C
#define C2TFI2			0xE0048040
#define C2TID2			0xE0048044
#define C2TDA2			0xE0048048
#define C2TDB2			0xE004804C
#define C2TFI3			0xE0048050
#define C2TID3			0xE0048054
#define C2TDA3			0xE0048058
#define C2TDB3			0xE004805C

/* CAN Controller 3 (CAN3) */
#define C3MOD			0xE004C000
#define C3CMR			0xE004C004
#define C3GSR			0xE004C008
#define C3ICR			0xE004C00C
#define C3IER			0xE004C010
#define C3BTR			0xE004C014
#define C3EWL			0xE004C018
#define C3SR			0xE004C01C
#define C3RFS			0xE004C020
#define C3RID			0xE004C024
#define C3RDA			0xE004C028
#define C3RDB			0xE004C02C
#define C3TFI1			0xE004C030
#define C3TID1			0xE004C034
#define C3TDA1			0xE004C038
#define C3TDB1			0xE004C03C
#define C3TFI2			0xE004C040
#define C3TID2			0xE004C044
#define C3TDA2			0xE004C048
#define C3TDB2			0xE004C04C
#define C3TFI3			0xE004C050
#define C3TID3			0xE004C054
#define C3TDA3			0xE004C058
#define C3TDB3			0xE004C05C

/* CAN Controller 4 (CAN4) */
#define C4MOD			0xE0050000
#define C4CMR			0xE0050004
#define C4GSR			0xE0050008
#define C4ICR			0xE005000C
#define C4IER			0xE0050010
#define C4BTR			0xE0050014
#define C4EWL			0xE0050018
#define C4SR			0xE005001C
#define C4RFS			0xE0050020
#define C4RID			0xE0050024
#define C4RDA			0xE0050028
#define C4RDB			0xE005002C
#define C4TFI1			0xE0050030
#define C4TID1			0xE0050034
#define C4TDA1			0xE0050038
#define C4TDB1			0xE005003C
#define C4TFI2			0xE0050040
#define C4TID2			0xE0050044
#define C4TDA2			0xE0050048
#define C4TDB2			0xE005004C
#define C4TFI3			0xE0050050
#define C4TID3			0xE0050054
#define C4TDA3			0xE0050058
#define C4TDB3			0xE005005C

/* Watchdog */
#define WDMOD			0xE0000000
#define WDTC			0xE0000004
#define WDFEED			0xE0000008
#define WDTV			0xE000000C

#endif /* __MACH_LPC2XXX_H */
